Index: uspace/lib/posix/stdlib.c
===================================================================
--- uspace/lib/posix/stdlib.c	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/stdlib.c	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -36,10 +36,12 @@
 #define LIBPOSIX_INTERNAL
 
+#include "internal/common.h"
 #include "stdlib.h"
+
+#include "errno.h"
+
 #include "libc/sort.h"
 #include "libc/str.h"
 #include "libc/vfs/vfs.h"
-#include "internal/common.h"
-#include <errno.h>  // FIXME: use POSIX errno
 
 /**
@@ -338,4 +340,16 @@
 }
 
+/**
+ * Should read system load statistics. Not supported. Always returns -1.
+ *
+ * @param loadavg
+ * @param nelem
+ * @return
+ */
+int bsd_getloadavg(double loadavg[], int nelem)
+{
+	return -1;
+}
+
 /** @}
  */
Index: uspace/lib/posix/stdlib.h
===================================================================
--- uspace/lib/posix/stdlib.h	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/stdlib.h	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -120,4 +120,5 @@
 /* Legacy Declarations */
 extern char *posix_mktemp(char *tmpl);
+extern int bsd_getloadavg(double loadavg[], int nelem);
 
 #ifndef LIBPOSIX_INTERNAL
@@ -163,4 +164,5 @@
 
 	#define mktemp posix_mktemp
+	#define getloadavg bsd_getloadavg
 #endif
 
Index: uspace/lib/posix/stdlib/strtol.c
===================================================================
--- uspace/lib/posix/stdlib/strtol.c	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/stdlib/strtol.c	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -37,7 +37,8 @@
 #include "../internal/common.h"
 #include "../stdlib.h"
-#include <errno.h>  // FIXME: use POSIX errno
+
 #include "../limits.h"
 #include "../ctype.h"
+#include "../errno.h"
 
 // TODO: documentation
Index: uspace/lib/posix/stdlib/strtold.c
===================================================================
--- uspace/lib/posix/stdlib/strtold.c	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/stdlib/strtold.c	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -35,13 +35,15 @@
 #define LIBPOSIX_INTERNAL
 
+/* Must be first. */
+#include "../stdbool.h"
+
 #include "../internal/common.h"
-
-#include "../libc/assert.h"
+#include "../stdlib.h"
+
+#include "../assert.h"
 #include "../ctype.h"
-#include <errno.h> // TODO: use POSIX errno
-#include "../libc/bool.h"
 #include "../stdint.h"
-#include "../stdlib.h"
 #include "../strings.h"
+#include "../errno.h"
 
 #ifndef HUGE_VALL
Index: uspace/lib/posix/string.c
===================================================================
--- uspace/lib/posix/string.c	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/string.c	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -36,25 +36,14 @@
 #define LIBPOSIX_INTERNAL
 
+#include "internal/common.h"
 #include "string.h"
 
-#include <assert.h>
-#include <str_error.h>
-#include <stdlib.h>
-#include <errno.h>
-
-/**
- * Defined for convenience. Returns pointer to the terminating nul character.
- *
- * @param s
- * @return
- */
-static char *strzero(const char *s)
-{
-	while (*s != '\0') {
-		s++;
-	}
-
-	return (char *) s;
-}
+#include "assert.h"
+#include "errno.h"
+#include "limits.h"
+#include "stdlib.h"
+#include "signal.h"
+
+#include "libc/str_error.h"
 
 /**
@@ -183,5 +172,5 @@
 	assert(src != NULL);
 
-	posix_strcpy(strzero(dest), src);
+	posix_strcpy(posix_strchr(dest, '\0'), src);
 	return dest;
 }
@@ -199,5 +188,5 @@
 	assert(src != NULL);
 
-	char *zeroptr = posix_strncpy(strzero(dest), src, n);
+	char *zeroptr = posix_strncpy(posix_strchr(dest, '\0'), src, n);
 	/* strncpy doesn't append the nul terminator, so we do it here */
 	zeroptr[n] = '\0';
@@ -240,6 +229,5 @@
 char *posix_strdup(const char *s)
 {
-	// FIXME: SIZE_MAX doesn't work
-	return posix_strndup(s, STR_NO_LIMIT);
+	return posix_strndup(s, SIZE_MAX);
 }
 
@@ -360,19 +348,6 @@
 	assert(s != NULL);
 	
-	/* special handling for the case that zero is searched for */
-	if (c == '\0') {
-		return strzero(s);
-	}
-	
-	/* otherwise just loop through the string until found */
-	while (*s != (char) c) {
-		if (*s == '\0') {
-			return NULL;
-		}
-
-		s++;
-	}
-	
-	return (char *) s;
+	char *res = gnu_strchrnul(s, c);
+	return (*res == c) ? res : NULL;
 }
 
@@ -387,5 +362,5 @@
 	assert(s != NULL);
 	
-	const char *ptr = strzero(s);
+	const char *ptr = posix_strchr(s, '\0');
 	
 	/* the same as in strchr, except it loops in reverse direction */
@@ -399,4 +374,15 @@
 
 	return (char *) ptr;
+}
+
+char *gnu_strchrnul(const char *s, int c)
+{
+	assert(s != NULL);
+	
+	while (*s != c && *s != '\0') {
+		s++;
+	}
+	
+	return (char *) s;
 }
 
@@ -524,8 +510,9 @@
 char *posix_strerror(int errnum)
 {
-	/* uses function from libc, we just have to negate errno
-	 * (POSIX uses positive errorcodes, HelenOS has negative)
+	/* Uses function from libc, we just have to negate errno
+	 * (POSIX uses positive errorcodes, HelenOS has negative).
 	 */
-	return (char *) str_error(-errnum);
+	// FIXME: not all POSIX error codes are in libc
+	return (char *) str_error(-posix_abs(errnum));
 }
 
@@ -562,5 +549,5 @@
 	assert(s != NULL);
 	
-	return (size_t) (strzero(s) - s);
+	return (size_t) (posix_strchr(s, '\0') - s);
 }
 
@@ -585,4 +572,49 @@
 }
 
+/**
+ *
+ * @param signum
+ * @return
+ */
+char *posix_strsignal(int signum)
+{
+	static const char *const sigstrings[] = {
+		[SIGABRT] = "SIGABRT (Process abort signal)",
+		[SIGALRM] = "SIGALRM (Alarm clock)",
+		[SIGBUS] = "SIGBUS (Access to an undefined portion of a memory object)",
+		[SIGCHLD] = "SIGCHLD (Child process terminated, stopped, or continued)",
+		[SIGCONT] = "SIGCONT (Continue executing, if stopped)",
+		[SIGFPE] = "SIGFPE (Erroneous arithmetic operation)",
+		[SIGHUP] = "SIGHUP (Hangup)",
+		[SIGILL] = "SIGILL (Illegal instruction)",
+		[SIGINT] = "SIGINT (Terminal interrupt signal)",
+		[SIGKILL] = "SIGKILL (Kill process)",
+		[SIGPIPE] = "SIGPIPE (Write on a pipe with no one to read it)",
+		[SIGQUIT] = "SIGQUIT (Terminal quit signal)",
+		[SIGSEGV] = "SIGSEGV (Invalid memory reference)",
+		[SIGSTOP] = "SIGSTOP (Stop executing)",
+		[SIGTERM] = "SIGTERM (Termination signal)",
+		[SIGTSTP] = "SIGTSTP (Terminal stop signal)",
+		[SIGTTIN] = "SIGTTIN (Background process attempting read)",
+		[SIGTTOU] = "SIGTTOU (Background process attempting write)",
+		[SIGUSR1] = "SIGUSR1 (User-defined signal 1)",
+		[SIGUSR2] = "SIGUSR2 (User-defined signal 2)",
+		[SIGPOLL] = "SIGPOLL (Pollable event)",
+		[SIGPROF] = "SIGPROF (Profiling timer expired)",
+		[SIGSYS] = "SIGSYS (Bad system call)",
+		[SIGTRAP] = "SIGTRAP (Trace/breakpoint trap)",
+		[SIGURG] = "SIGURG (High bandwidth data is available at a socket)",
+		[SIGVTALRM] = "SIGVTALRM (Virtual timer expired)",
+		[SIGXCPU] = "SIGXCPU (CPU time limit exceeded)",
+		[SIGXFSZ] = "SIGXFSZ (File size limit exceeded)"
+	};
+
+	if (signum <= _TOP_SIGNAL) {
+		return (char *) sigstrings[signum];
+	}
+
+	return (char *) "ERROR, Invalid signal number";
+}
+
 /** @}
  */
Index: uspace/lib/posix/string.h
===================================================================
--- uspace/lib/posix/string.h	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/string.h	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -85,4 +85,5 @@
 extern char *posix_strchr(const char *s, int c);
 extern char *posix_strrchr(const char *s, int c);
+extern char *gnu_strchrnul(const char *s, int c);
 extern char *posix_strpbrk(const char *s1, const char *s2);
 extern size_t posix_strcspn(const char *s1, const char *s2);
@@ -101,4 +102,7 @@
 extern size_t posix_strlen(const char *s);
 extern size_t posix_strnlen(const char *s, size_t n);
+
+/* Signal messages */
+extern char *posix_strsignal(int signum);
 
 /* Legacy declarations */
@@ -127,4 +131,5 @@
 	#define strchr posix_strchr
 	#define strrchr posix_strrchr
+	#define strchrnul gnu_strchrnul
 	#define strpbrk posix_strpbrk
 	#define strcspn posix_strcspn
@@ -141,4 +146,6 @@
 	#define strnlen posix_strnlen
 
+	#define strsignal posix_strsignal
+
 	#define ffs posix_ffs
 	#define strcasecmp posix_strcasecmp
Index: uspace/lib/posix/sys/stat.c
===================================================================
--- uspace/lib/posix/sys/stat.c	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/sys/stat.c	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -36,13 +36,15 @@
 #define LIBPOSIX_INTERNAL
 
+#include "../internal/common.h"
 #include "stat.h"
-#include "../internal/common.h"
-#include <mem.h>
+
+#include "../errno.h"
+#include "../libc/mem.h"
 
 /**
- * Convert HelenOS stat struct into POSIX stat struct (if possible)
+ * Convert HelenOS stat struct into POSIX stat struct (if possible).
  *
- * @param dest
- * @param src
+ * @param dest POSIX stat struct.
+ * @param src HelenOS stat struct.
  */
 static void stat_to_posix(struct posix_stat *dest, struct stat *src)
@@ -66,14 +68,18 @@
 
 /**
+ * Retrieve file status for file associated with file descriptor.
  *
- * @param fd
- * @param st
- * @return
+ * @param fd File descriptor of the opened file.
+ * @param st Status structure to be filled with information.
+ * @return Zero on success, -1 otherwise.
  */
 int posix_fstat(int fd, struct posix_stat *st)
 {
 	struct stat hst;
-	if (fstat(fd, &hst) == -1) {
-		// TODO: propagate a POSIX compatible errno
+	int rc = fstat(fd, &hst);
+	if (rc < 0) {
+		/* fstat() returns negative error code instead of using errno.
+		 */
+		errno = -rc;
 		return -1;
 	}
@@ -83,26 +89,31 @@
 
 /**
+ * Retrieve file status for symbolic link.
  * 
- * @param path
- * @param st
- * @return
+ * @param path Path to the symbolic link.
+ * @param st Status structure to be filled with information.
+ * @return Zero on success, -1 otherwise.
  */
-int posix_lstat(const char *restrict path, struct posix_stat *restrict st)
+int posix_lstat(const char *path, struct posix_stat *st)
 {
-	// TODO
-	not_implemented();
+	/* There are currently no symbolic links in HelenOS. */
+	return posix_stat(path, st);
 }
 
 /**
+ * Retrieve file status for regular file (or symbolic link target).
  *
- * @param path
- * @param st
- * @return
+ * @param path Path to the file/link.
+ * @param st Status structure to be filled with information.
+ * @return Zero on success, -1 otherwise.
  */
 int posix_stat(const char *path, struct posix_stat *st)
 {
 	struct stat hst;
-	if (stat(path, &hst) == -1) {
-		// TODO: propagate a POSIX compatible errno
+	int rc = stat(path, &hst);
+	if (rc < 0) {
+		/* stat() returns negative error code instead of using errno.
+		 */
+		errno = -rc;
 		return -1;
 	}
@@ -112,24 +123,27 @@
 
 /**
+ * Change permission bits for the file if possible.
  * 
- * @param path
- * @param mode
- * @return
+ * @param path Path to the file.
+ * @param mode Permission bits to be set.
+ * @return Zero on success, -1 otherwise.
  */
 int posix_chmod(const char *path, mode_t mode)
 {
-	// TODO
-	not_implemented();
+	/* HelenOS doesn't support permissions, return success. */
+	return 0;
 }
 
 /**
+ * Set the file mode creation mask of the process.
  * 
- * @param mask
- * @return
+ * @param mask Set permission bits are cleared in the related creation
+ *     functions. Non-permission bits are ignored.
+ * @return Previous file mode creation mask.
  */
 mode_t posix_umask(mode_t mask)
 {
-	// TODO
-	not_implemented();
+	/* HelenOS doesn't support permissions, return empty mask. */
+	return 0;
 }
 
Index: uspace/lib/posix/sys/types.h
===================================================================
--- uspace/lib/posix/sys/types.h	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/sys/types.h	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -52,4 +52,8 @@
 typedef struct posix_thread_attr posix_thread_attr_t;
 
+/* Clock types */
+typedef long posix_clock_t;
+typedef int posix_clockid_t;
+
 #ifndef LIBPOSIX_INTERNAL
 	#define ino_t posix_ino_t
@@ -64,4 +68,7 @@
 	
 	#define pthread_attr_t posix_thread_attr_t
+	
+	#define clock_t posix_clock_t
+	#define clockid_t posix_clockid_t
 #endif
 
Index: uspace/lib/posix/time.c
===================================================================
--- uspace/lib/posix/time.c	(revision f5b25224f3b95c0a700f5f9f6c8bb2ecad2c28f0)
+++ uspace/lib/posix/time.c	(revision 8cd8bf61fa7549be36c3193a2eff646b2c0f84ec)
@@ -36,7 +36,360 @@
 #define LIBPOSIX_INTERNAL
 
+/* Must be first. */
+#include "stdbool.h"
+
 #include "internal/common.h"
 #include "time.h"
 
+#include "ctype.h"
+#include "errno.h"
+#include "signal.h"
+
+#include "libc/malloc.h"
+#include "libc/task.h"
+#include "libc/stats.h"
+#include "libc/sys/time.h"
+
+// TODO: documentation
+// TODO: test everything in this file
+
+/* Helper functions ***********************************************************/
+
+#define HOURS_PER_DAY (24)
+#define MINS_PER_HOUR (60)
+#define SECS_PER_MIN (60)
+#define MINS_PER_DAY (MINS_PER_HOUR * HOURS_PER_DAY)
+#define SECS_PER_HOUR (SECS_PER_MIN * MINS_PER_HOUR)
+#define SECS_PER_DAY (SECS_PER_HOUR * HOURS_PER_DAY)
+
+static bool _is_leap_year(time_t year)
+{
+	year += 1900;
+
+	if (year % 400 == 0)
+		return true;
+	if (year % 100 == 0)
+		return false;
+	if (year % 4 == 0)
+		return true;
+	return false;
+}
+
+static int _days_in_month(time_t year, time_t mon)
+{
+	assert(mon >= 0 && mon <= 11);
+	year += 1900;
+
+	static int month_days[] =
+		{ 31, 0, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
+
+	if (mon == 1) {
+		/* february */
+		return _is_leap_year(year) ? 29 : 28;
+	} else {
+		return month_days[mon];
+	}
+}
+
+static int _day_of_year(time_t year, time_t mon, time_t mday)
+{
+	static int mdays[] =
+	    { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };
+	static int leap_mdays[] =
+	    { 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335 };
+
+	return (_is_leap_year(year) ? leap_mdays[mon] : mdays[mon]) + mday - 1;
+}
+
+/* Integer division that rounds to negative infinity.
+ */
+static time_t _floor_div(time_t op1, time_t op2)
+{
+	if (op1 >= 0 || op1 % op2 == 0) {
+		return op1 / op2;
+	} else {
+		return op1 / op2 - 1;
+	}
+}
+
+/* Modulo that rounds to negative infinity.
+ */
+static time_t _floor_mod(time_t op1, time_t op2)
+{
+	int div = _floor_div(op1, op2);
+
+	/* (a / b) * b + a % b == a */
+	/* thus, a % b == a - (a / b) * b */
+
+	int result = op1 - div * op2;
+	
+	/* Some paranoid checking to ensure I didn't make a mistake here. */
+	assert(result >= 0);
+	assert(result < op2);
+	assert(div * op2 + result == op1);
+	
+	return result;
+}
+
+static time_t _days_since_epoch(time_t year, time_t mon, time_t mday)
+{
+	return (year - 70) * 365 + _floor_div(year - 69, 4) -
+	    _floor_div(year - 1, 100) + _floor_div(year + 299, 400) +
+	    _day_of_year(year, mon, mday);
+}
+
+/* Assumes normalized broken-down time. */
+static time_t _secs_since_epoch(const struct posix_tm *tm)
+{
+	return _days_since_epoch(tm->tm_year, tm->tm_mon, tm->tm_mday) *
+	    SECS_PER_DAY + tm->tm_hour * SECS_PER_HOUR +
+	    tm->tm_min * SECS_PER_MIN + tm->tm_sec;
+}
+
+static int _day_of_week(time_t year, time_t mon, time_t mday)
+{
+	/* 1970-01-01 is Thursday */
+	return (_days_since_epoch(year, mon, mday) + 4) % 7;
+}
+
+struct _long_tm {
+	time_t tm_sec;
+	time_t tm_min;
+	time_t tm_hour;
+	time_t tm_mday;
+	time_t tm_mon;
+	time_t tm_year;
+	int tm_wday;
+	int tm_yday;
+	int tm_isdst;
+};
+
+static void _posix_to_long_tm(struct _long_tm *ltm, struct posix_tm *ptm)
+{
+	assert(ltm != NULL && ptm != NULL);
+	ltm->tm_sec = ptm->tm_sec;
+	ltm->tm_min = ptm->tm_min;
+	ltm->tm_hour = ptm->tm_hour;
+	ltm->tm_mday = ptm->tm_mday;
+	ltm->tm_mon = ptm->tm_mon;
+	ltm->tm_year = ptm->tm_year;
+	ltm->tm_wday = ptm->tm_wday;
+	ltm->tm_yday = ptm->tm_yday;
+	ltm->tm_isdst = ptm->tm_isdst;
+}
+
+static void _long_to_posix_tm(struct posix_tm *ptm, struct _long_tm *ltm)
+{
+	assert(ltm != NULL && ptm != NULL);
+	// FIXME: the cast should be unnecessary, libarch/common.h brain-damage
+	assert((ltm->tm_year >= (int) INT_MIN) && (ltm->tm_year <= (int) INT_MAX));
+
+	ptm->tm_sec = ltm->tm_sec;
+	ptm->tm_min = ltm->tm_min;
+	ptm->tm_hour = ltm->tm_hour;
+	ptm->tm_mday = ltm->tm_mday;
+	ptm->tm_mon = ltm->tm_mon;
+	ptm->tm_year = ltm->tm_year;
+	ptm->tm_wday = ltm->tm_wday;
+	ptm->tm_yday = ltm->tm_yday;
+	ptm->tm_isdst = ltm->tm_isdst;
+}
+
+static void _normalize_time(struct _long_tm *tm)
+{
+	// TODO: DST correction
+
+	/* Adjust time. */
+	tm->tm_min += _floor_div(tm->tm_sec, SECS_PER_MIN);
+	tm->tm_sec = _floor_mod(tm->tm_sec, SECS_PER_MIN);
+	tm->tm_hour += _floor_div(tm->tm_min, MINS_PER_HOUR);
+	tm->tm_min = _floor_mod(tm->tm_min, MINS_PER_HOUR);
+	tm->tm_mday += _floor_div(tm->tm_hour, HOURS_PER_DAY);
+	tm->tm_hour = _floor_mod(tm->tm_hour, HOURS_PER_DAY);
+
+	/* Adjust month. */
+	tm->tm_year += _floor_div(tm->tm_mon, 12);
+	tm->tm_mon = _floor_mod(tm->tm_mon, 12);
+
+	/* Now the difficult part - days of month. */
+	/* Slow, but simple. */
+	// FIXME: do this faster
+
+	while (tm->tm_mday < 1) {
+		tm->tm_mon--;
+		if (tm->tm_mon == -1) {
+			tm->tm_mon = 11;
+			tm->tm_year--;
+		}
+		
+		tm->tm_mday += _days_in_month(tm->tm_year, tm->tm_mon);
+	}
+
+	while (tm->tm_mday > _days_in_month(tm->tm_year, tm->tm_mon)) {
+		tm->tm_mday -= _days_in_month(tm->tm_year, tm->tm_mon);
+		
+		tm->tm_mon++;
+		if (tm->tm_mon == 12) {
+			tm->tm_mon = 0;
+			tm->tm_year++;
+		}
+	}
+
+	/* Calculate the remaining two fields. */
+	tm->tm_yday = _day_of_year(tm->tm_year, tm->tm_mon, tm->tm_mday);
+	tm->tm_wday = _day_of_week(tm->tm_year, tm->tm_mon, tm->tm_mday);
+}
+
+/* Which day the week-based year starts on relative to the first calendar day.
+ * E.g. if the year starts on December 31st, the return value is -1.
+ */
+static int _wbyear_offset(int year)
+{
+	int start_wday = _day_of_week(year, 0, 1);
+	return _floor_mod(4 - start_wday, 7) - 3;
+}
+
+/* Returns week-based year of the specified time.
+ * Assumes normalized broken-down time.
+ */
+static int _wbyear(const struct posix_tm *tm)
+{
+	int day = tm->tm_yday - _wbyear_offset(tm->tm_year);
+	if (day < 0) {
+		/* Last week of previous year. */
+		return tm->tm_year - 1;
+	}
+	if (day > 364 + _is_leap_year(tm->tm_year)){
+		/* First week of next year. */
+		return tm->tm_year + 1;
+	}
+	/* All the other days are in the calendar year. */
+	return tm->tm_year;
+}
+
+/** Week number of the year, assuming weeks start on sunday.
+ *  The first Sunday of January is the first day of week 1;
+ *  days in the new year before this are in week 0.
+ *
+ * @param tm Normalized broken-down time.
+ * @return The week number (0 - 53).
+ */
+static int _sun_week_number(const struct posix_tm *tm)
+{
+	int first_day = (7 - _day_of_week(tm->tm_year, 0, 1)) % 7;
+	return (tm->tm_yday - first_day + 7) / 7;
+}
+
+/** Week number of the year, assuming weeks start on monday.
+ *  If the week containing January 1st has four or more days in the new year,
+ *  then it is considered week 1. Otherwise, it is the last week of the previous
+ *  year, and the next week is week 1. Both January 4th and the first Thursday
+ *  of January are always in week 1.
+ *
+ * @param tm Normalized broken-down time.
+ * @return The week number (1 - 53).
+ */
+static int _iso_week_number(const struct posix_tm *tm)
+{
+	int day = tm->tm_yday - _wbyear_offset(tm->tm_year);
+	if (day < 0) {
+		/* Last week of previous year. */
+		return 53;
+	}
+	if (day > 364 + _is_leap_year(tm->tm_year)){
+		/* First week of next year. */
+		return 1;
+	}
+	/* All the other days give correct answer. */
+	return (day / 7 + 1);
+}
+
+/** Week number of the year, assuming weeks start on monday.
+ *  The first Monday of January is the first day of week 1;
+ *  days in the new year before this are in week 0. 
+ *
+ * @param tm Normalized broken-down time.
+ * @return The week number (0 - 53).
+ */
+static int _mon_week_number(const struct posix_tm *tm)
+{
+	int first_day = (1 - _day_of_week(tm->tm_year, 0, 1)) % 7;
+	return (tm->tm_yday - first_day + 7) / 7;
+}
+
+/******************************************************************************/
+
+int posix_daylight;
+long posix_timezone;
+char *posix_tzname[2];
+
+void posix_tzset(void)
+{
+	// TODO: read environment
+	posix_tzname[0] = (char *) "GMT";
+	posix_tzname[1] = (char *) "GMT";
+	posix_daylight = 0;
+	posix_timezone = 0;
+}
+
+double posix_difftime(time_t time1, time_t time0)
+{
+	return (double) (time1 - time0);
+}
+
+/** This function first normalizes the provided broken-down time
+ *  (moves all values to their proper bounds) and then tries to
+ *  calculate the appropriate time_t representation.
+ *
+ * @param timeptr Broken-down time.
+ * @return time_t representation of the time, undefined value on overflow
+ */
+time_t posix_mktime(struct posix_tm *tm)
+{
+	// TODO: take DST flag into account
+	// TODO: detect overflow
+
+	struct _long_tm ltm;
+	_posix_to_long_tm(&ltm, tm);
+	_normalize_time(&ltm);
+	_long_to_posix_tm(tm, &ltm);
+
+	return _secs_since_epoch(tm);
+}
+
+struct posix_tm *posix_gmtime(const time_t *timer)
+{
+	static struct posix_tm result;
+	return posix_gmtime_r(timer, &result);
+}
+
+struct posix_tm *posix_gmtime_r(const time_t *restrict timer,
+    struct posix_tm *restrict result)
+{
+	assert(timer != NULL);
+	assert(result != NULL);
+
+	/* Set epoch and seconds to _long_tm struct and normalize to get
+	 * correct values.
+	 */
+	struct _long_tm ltm = {
+		.tm_sec = *timer,
+		.tm_min = 0,
+		.tm_hour = 0, /* 00:00:xx */
+		.tm_mday = 1,
+		.tm_mon = 0, /* January 1st */
+		.tm_year = 70, /* 1970 */
+	};
+	_normalize_time(&ltm);
+
+	if (ltm.tm_year < (int) INT_MIN || ltm.tm_year > (int) INT_MAX) {
+		errno = EOVERFLOW;
+		return NULL;
+	}
+
+	_long_to_posix_tm(result, &ltm);
+	return result;
+}
+
 /**
  *
@@ -44,9 +397,16 @@
  * @return
  */
-struct posix_tm *posix_localtime(const time_t *timep)
-{
-	// TODO
-	static struct posix_tm result = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
-	return &result;
+struct posix_tm *posix_localtime(const time_t *timer)
+{
+	static struct posix_tm result;
+	return posix_localtime_r(timer, &result);
+}
+
+struct posix_tm *posix_localtime_r(const time_t *restrict timer,
+    struct posix_tm *restrict result)
+{
+	// TODO: deal with timezone
+	// currently assumes system and all times are in GMT
+	return posix_gmtime_r(timer, result);
 }
 
@@ -56,9 +416,32 @@
  * @return
  */
-char *posix_asctime(const struct posix_tm *tm)
-{
-	// TODO
-	static char result[] = "Sun Jan 01 00:00:00 1900\n";
-	return result;
+char *posix_asctime(const struct posix_tm *timeptr)
+{
+	static char buf[ASCTIME_BUF_LEN];
+	return posix_asctime_r(timeptr, buf);
+}
+
+char *posix_asctime_r(const struct posix_tm *restrict timeptr,
+    char *restrict buf)
+{
+	assert(timeptr != NULL);
+	assert(buf != NULL);
+
+	static const char *wday[] = {
+		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
+	};
+	static const char *mon[] = {
+		"Jan", "Feb", "Mar", "Apr", "May", "Jun",
+		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
+	};
+
+	snprintf(buf, ASCTIME_BUF_LEN, "%s %s %2d %02d:%02d:%02d %d\n",
+	    wday[timeptr->tm_wday],
+	    mon[timeptr->tm_mon],
+	    timeptr->tm_mday, timeptr->tm_hour,
+	    timeptr->tm_min, timeptr->tm_sec,
+	    1900 + timeptr->tm_year);
+
+	return buf;
 }
 
@@ -68,7 +451,20 @@
  * @return
  */
-char *posix_ctime(const time_t *timep)
-{
-	return posix_asctime(posix_localtime(timep));
+char *posix_ctime(const time_t *timer)
+{
+	struct posix_tm *loctime = posix_localtime(timer);
+	if (loctime == NULL) {
+		return NULL;
+	}
+	return posix_asctime(loctime);
+}
+
+char *posix_ctime_r(const time_t *timer, char *buf)
+{
+	struct posix_tm loctime;
+	if (posix_localtime_r(timer, &loctime) == NULL) {
+		return NULL;
+	}
+	return posix_asctime_r(&loctime, buf);
 }
 
@@ -81,5 +477,265 @@
  * @return
  */
-size_t posix_strftime(char *s, size_t maxsize, const char *format, const struct posix_tm *tm)
+size_t posix_strftime(char *s, size_t maxsize,
+    const char *format, const struct posix_tm *tm)
+{
+	// TODO: use locale
+	static const char *wday_abbr[] = {
+		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
+	};
+	static const char *wday[] = {
+		"Sunday", "Monday", "Tuesday", "Wednesday",
+		"Thursday", "Friday", "Saturday"
+	};
+	static const char *mon_abbr[] = {
+		"Jan", "Feb", "Mar", "Apr", "May", "Jun",
+		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
+	};
+	static const char *mon[] = {
+		"January", "February", "March", "April", "May", "June", "July",
+		"August", "September", "October", "November", "December"
+	};
+	
+	if (maxsize < 1) {
+		return 0;
+	}
+	
+	char *ptr = s;
+	size_t consumed;
+	size_t remaining = maxsize;
+	
+	#define append(...) { \
+		/* FIXME: this requires POSIX-correct snprintf */ \
+		/*        otherwise it won't work with non-ascii chars */ \
+		consumed = snprintf(ptr, remaining, __VA_ARGS__); \
+		if (consumed >= remaining) { \
+			return 0; \
+		} \
+		ptr += consumed; \
+		remaining -= consumed; \
+	}
+	
+	#define recurse(fmt) { \
+		consumed = posix_strftime(ptr, remaining, fmt, tm); \
+		if (consumed == 0) { \
+			return 0; \
+		} \
+		ptr += consumed; \
+		remaining -= consumed; \
+	}
+	
+	#define TO_12H(hour) (((hour) > 12) ? ((hour) - 12) : \
+	    (((hour) == 0) ? 12 : (hour)))
+	
+	while (*format != '\0') {
+		if (*format != '%') {
+			append("%c", *format);
+			format++;
+			continue;
+		}
+		
+		format++;
+		if (*format == '0' || *format == '+') {
+			// TODO: padding
+			format++;
+		}
+		while (isdigit(*format)) {
+			// TODO: padding
+			format++;
+		}
+		if (*format == 'O' || *format == 'E') {
+			// TODO: locale's alternative format
+			format++;
+		}
+		
+		switch (*format) {
+		case 'a':
+			append("%s", wday_abbr[tm->tm_wday]); break;
+		case 'A':
+			append("%s", wday[tm->tm_wday]); break;
+		case 'b':
+			append("%s", mon_abbr[tm->tm_mon]); break;
+		case 'B':
+			append("%s", mon[tm->tm_mon]); break;
+		case 'c':
+			// TODO: locale-specific datetime format
+			recurse("%Y-%m-%d %H:%M:%S"); break;
+		case 'C':
+			append("%02d", (1900 + tm->tm_year) / 100); break;
+		case 'd':
+			append("%02d", tm->tm_mday); break;
+		case 'D':
+			recurse("%m/%d/%y"); break;
+		case 'e':
+			append("%2d", tm->tm_mday); break;
+		case 'F':
+			recurse("%+4Y-%m-%d"); break;
+		case 'g':
+			append("%02d", _wbyear(tm) % 100); break;
+		case 'G':
+			append("%d", _wbyear(tm)); break;
+		case 'h':
+			recurse("%b"); break;
+		case 'H':
+			append("%02d", tm->tm_hour); break;
+		case 'I':
+			append("%02d", TO_12H(tm->tm_hour)); break;
+		case 'j':
+			append("%03d", tm->tm_yday); break;
+		case 'k':
+			append("%2d", tm->tm_hour); break;
+		case 'l':
+			append("%2d", TO_12H(tm->tm_hour)); break;
+		case 'm':
+			append("%02d", tm->tm_mon); break;
+		case 'M':
+			append("%02d", tm->tm_min); break;
+		case 'n':
+			append("\n"); break;
+		case 'p':
+			append("%s", tm->tm_hour < 12 ? "AM" : "PM"); break;
+		case 'P':
+			append("%s", tm->tm_hour < 12 ? "am" : "PM"); break;
+		case 'r':
+			recurse("%I:%M:%S %p"); break;
+		case 'R':
+			recurse("%H:%M"); break;
+		case 's':
+			append("%ld", _secs_since_epoch(tm)); break;
+		case 'S':
+			append("%02d", tm->tm_sec); break;
+		case 't':
+			append("\t"); break;
+		case 'T':
+			recurse("%H:%M:%S"); break;
+		case 'u':
+			append("%d", (tm->tm_wday == 0) ? 7 : tm->tm_wday); break;
+		case 'U':
+			append("%02d", _sun_week_number(tm)); break;
+		case 'V':
+			append("%02d", _iso_week_number(tm)); break;
+		case 'w':
+			append("%d", tm->tm_wday); break;
+		case 'W':
+			append("%02d", _mon_week_number(tm)); break;
+		case 'x':
+			// TODO: locale-specific date format
+			recurse("%Y-%m-%d"); break;
+		case 'X':
+			// TODO: locale-specific time format
+			recurse("%H:%M:%S"); break;
+		case 'y':
+			append("%02d", tm->tm_year % 100); break;
+		case 'Y':
+			append("%d", 1900 + tm->tm_year); break;
+		case 'z':
+			// TODO: timezone
+			break;
+		case 'Z':
+			// TODO: timezone
+			break;
+		case '%':
+			append("%%");
+			break;
+		default:
+			/* Invalid specifier, print verbatim. */
+			while (*format != '%') {
+				format--;
+			}
+			append("%%");
+			break;
+		}
+		format++;
+	}
+	
+	#undef append
+	#undef recurse
+	
+	return maxsize - remaining;
+}
+
+int posix_clock_getres(posix_clockid_t clock_id, struct posix_timespec *res)
+{
+	assert(res != NULL);
+
+	switch (clock_id) {
+		case CLOCK_REALTIME:
+			res->tv_sec = 0;
+			res->tv_nsec = 1000; /* Microsecond resolution. */
+			return 0;
+		default:
+			errno = EINVAL;
+			return -1;
+	}
+}
+
+int posix_clock_gettime(posix_clockid_t clock_id, struct posix_timespec *tp)
+{
+	assert(tp != NULL);
+
+	switch (clock_id) {
+		case CLOCK_REALTIME:
+			;
+			struct timeval tv;
+			gettimeofday(&tv, NULL);
+			tp->tv_sec = tv.tv_sec;
+			tp->tv_nsec = tv.tv_usec * 1000;
+			return 0;
+		default:
+			errno = EINVAL;
+			return -1;
+	}
+}
+
+int posix_clock_settime(posix_clockid_t clock_id,
+    const struct posix_timespec *tp)
+{
+	assert(tp != NULL);
+
+	switch (clock_id) {
+		case CLOCK_REALTIME:
+			// TODO: setting clock
+			// FIXME: HelenOS doesn't actually support hardware
+			//        clock yet
+			errno = EPERM;
+			return -1;
+		default:
+			errno = EINVAL;
+			return -1;
+	}
+}
+
+int posix_clock_nanosleep(posix_clockid_t clock_id, int flags,
+    const struct posix_timespec *rqtp, struct posix_timespec *rmtp)
+{
+	assert(rqtp != NULL);
+	assert(rmtp != NULL);
+
+	switch (clock_id) {
+		case CLOCK_REALTIME:
+			// TODO: interruptible sleep
+			if (rqtp->tv_sec != 0) {
+				sleep(rqtp->tv_sec);
+			}
+			if (rqtp->tv_nsec != 0) {
+				usleep(rqtp->tv_nsec / 1000);
+			}
+			return 0;
+		default:
+			errno = EINVAL;
+			return -1;
+	}
+}
+
+#if 0
+
+struct __posix_timer {
+	posix_clockid_t clockid;
+	struct posix_sigevent evp;
+};
+
+int posix_timer_create(posix_clockid_t clockid,
+    struct posix_sigevent *restrict evp,
+    posix_timer_t *restrict timerid)
 {
 	// TODO
@@ -87,9 +743,5 @@
 }
 
-/**
- * 
- * @return
- */
-posix_clock_t posix_clock(void)
+int posix_timer_delete(posix_timer_t timerid)
 {
 	// TODO
@@ -97,4 +749,45 @@
 }
 
+int posix_timer_getoverrun(posix_timer_t timerid)
+{
+	// TODO
+	not_implemented();
+}
+
+int posix_timer_gettime(posix_timer_t timerid,
+    struct posix_itimerspec *value)
+{
+	// TODO
+	not_implemented();
+}
+
+int posix_timer_settime(posix_timer_t timerid, int flags,
+    const struct posix_itimerspec *restrict value,
+    struct posix_itimerspec *restrict ovalue)
+{
+	// TODO
+	not_implemented();
+}
+
+#endif
+
+/**
+ * Get CPU time used since the process invocation.
+ *
+ * @return Consumed CPU cycles by this process or -1 if not available.
+ */
+posix_clock_t posix_clock(void)
+{
+	posix_clock_t total_cycles = -1;
+	stats_task_t *task_stats = stats_get_task(task_get_id());
+	if (task_stats) {
+		total_cycles = (posix_clock_t) (task_stats->kcycles + task_stats->ucycles);
+	}
+	free(task_stats);
+	task_stats = 0;
+
+	return total_cycles;
+}
+
 /** @}
  */
